<?php
namespace Incoviba\Repository\Proyecto;

use Incoviba\Common\Ideal;
use Incoviba\Common\Define;
use Incoviba\Common\Implement;
use Incoviba\Model;

class Elemento extends Ideal\Repository
{
    public function __construct(Define\Connection $connection)
    {
        parent::__construct($connection);
        $this->setTable('tipo_elemento');
    }

    public function create(?array $data = null): Model\Proyecto\Elemento
    {
        $map = new Implement\Repository\MapperParser(['descripcion', 'abreviacion', 'orden']);
        return $this->parseData(new Model\Proyecto\Elemento(), $data, $map);
    }
    public function save(Define\Model $model): Model\Proyecto\Elemento
    {
        $model->id = $this->saveNew(
            ['descripcion', 'abreviacion', 'orden'],
            [$model->descripcion, $model->abreviacion, $model->orden]
        );
        return $model;
    }
    public function edit(Define\Model $model, array $new_data): Model\Proyecto\Elemento
    {
        return $this->update($model, ['descripcion', 'abreviacion', 'orden'], $new_data);
    }
}
